//
//  IPController.h
//  iProcrastinate
//
//  Created by Craig Otis on 6/17/07.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import <MyDocument.h>
#import <iLifeControls/NFHUDWindow.h>
#import <ImageTextCell.h>
#import <IPTableView.h>
#import <SubjectTableView.h>
#import <SubjectTextCell.h>

@interface IPController : NSObject {
	BOOL burning;
	
	IBOutlet NSArrayController *subjectController;
	IBOutlet NSArrayController *taskController;
	IBOutlet NSArrayController *filesController;
	IBOutlet NSArrayController *archiveController;
	IBOutlet NSArrayController *stepController;
	
	IBOutlet NSTableView *taskTableView;
	IBOutlet NSTableView *archiveTableView;
	IBOutlet NSTableView *stepTableView;
	
	IBOutlet SubjectTableView *subjectTableView;
	
	IBOutlet IPTableView *filesTableView;
	
	IBOutlet NSTextField *subjectTitleField;
	IBOutlet NSTextField *addInfoField;
	IBOutlet NSTextField *notesTextField;
	
	IBOutlet NSColorWell *subjectColor;
	
	IBOutlet NSScrollView *filesScrollView;
	IBOutlet NSScrollView *stepsTableView;	
	
	IBOutlet NSSegmentedControl *noteStep;
	
	IBOutlet NSButton *addStepButton;
	IBOutlet NSButton *removeStepButton;
	IBOutlet NSButton *extraSpace;
	IBOutlet NSButton *burnButton;
	IBOutlet NSButton *addFileButton;
	IBOutlet NSButton *removeFileButton;
	IBOutlet NSButton *stepDatePickerButton;
	IBOutlet NSButton *taskDatePickerButton;
	IBOutlet NSButton *archiveTaskButton;
	
	IBOutlet NSWindow *mainWindow;
	IBOutlet NSWindow *subjectSheet;
	
	IBOutlet NFHUDWindow *helpPanel;
}

- (IBAction)addSubject:(id)sender;
- (IBAction)removeSubject:(id)sender;

- (IBAction)noteStepDidChange:(id)sender;

- (IBAction)burnFilesToCd:(id)sender;

- (IBAction)beginAddingSubject:(id)sender;
- (IBAction)cancelAddingSubject:(id)sender;

- (IBAction)addTask:(id)sender;
- (IBAction)removeTask:(id)sender;

- (IBAction)addStep:(id)sender;
- (IBAction)removeStep:(id)sender;

- (IBAction)archiveTask:(id)sender;
- (IBAction)restoreArchivedTask:(id)sender;

- (IBAction)showAllSubjects:(id)sender;

- (IBAction)addFile:(id)sender;
- (IBAction)removeThisFile:(id)sender;

- (IBAction)customOpenHelp:(id)sender;

@end
