//
//  MyDocument.m
//  iProcrastinate
//
//  Created by Craig Otis on 6/17/07.
//  Copyright __MyCompanyName__ 2007 . All rights reserved.
//

#import "MyDocument.h"

@implementation MyDocument

- (id)init 
{
    self = [super init];
    if (self != nil) {
		//initialization code
    }
    return self;
}

- (void)awakeFromNib {
	toolbar = [[NSToolbar alloc] initWithIdentifier:@"mainToolbar"];
	
	[toolbar setDelegate:self];
	[toolbar setAllowsUserCustomization:YES];
	[toolbar setAutosavesConfiguration:YES];
	
	[mainWindow setToolbar:toolbar];
	
	[toolbar autorelease];
}

- (NSToolbarItem *)toolbar:(NSToolbar *)tb
	 itemForItemIdentifier:(NSString *)tbit
 willBeInsertedIntoToolbar:(BOOL)flag
{
	NSToolbarItem *addClassItem = [[NSToolbarItem alloc] initWithItemIdentifier:tbit];
	
	if ( [tbit isEqualToString:@"SearchItem"] ) {
		NSRect fRect = [searchItemView frame];
		[addClassItem setLabel:@"Search Tasks"];
		[addClassItem setPaletteLabel:@"Search Tasks"];
		[addClassItem setView:searchItemView];
		[addClassItem setMinSize:fRect.size];
		[addClassItem setMaxSize:fRect.size];
    }
	if ([tbit isEqualToString:@"Add Subject"])
	{
		[addClassItem setLabel:@"Add Subject"];
		[addClassItem setPaletteLabel:@"Add Subject"];
		[addClassItem setImage:[NSImage imageNamed:@"subject_add.icns"]];
		[addClassItem setAction:@selector(addSubjectHelper)];
	} else
		if ([tbit isEqualToString:@"Remove Subject"])
		{
			[addClassItem setLabel:@"Remove Subject"];
			[addClassItem setPaletteLabel:@"Remove Subject"];
			[addClassItem setImage:[NSImage imageNamed:@"subject_remove.icns"]];
			[addClassItem setAction:@selector(removeSubject)];
		}else
			if ([tbit isEqualToString:@"Add Task"])
			{
				[addClassItem setLabel:@"Add Task"];
				[addClassItem setPaletteLabel:@"Add Task"];
				[addClassItem setImage:[NSImage imageNamed:@"task_add.icns"]];
				[addClassItem setAction:@selector(addTaskHelper)];
			} else
				if ([tbit isEqualToString:@"Remove Task"])
				{
					[addClassItem setLabel:@"Remove Task"];
					[addClassItem setPaletteLabel:@"Remove Task"];
					[addClassItem setImage:[NSImage imageNamed:@"task_remove.icns"]];
					[addClassItem setAction:@selector(removeTask)];
				} else
	{
		
		[addClassItem setLabel:@"Booga"];
		
		[addClassItem setImage:[NSImage imageNamed:@"Woof.gif"]];
		
		[addClassItem setAction:@selector(addSubject)];
	}
	
	[addClassItem autorelease];
    return addClassItem;
	
}

- (NSArray *)toolbarDefaultItemIdentifiers:(NSToolbar*)toolbar
{
    return [NSArray arrayWithObjects:@"Woof",NSToolbarSeparatorItemIdentifier,NSToolbarCustomizeToolbarItemIdentifier,NSToolbarFlexibleSpaceItemIdentifier,@"SearchItem",nil];
}

- (BOOL)validateToolbarItem:(NSToolbarItem *)theItem
{
	return YES;
}

- (NSArray *)toolbarAllowedItemIdentifiers:(NSToolbar*)toolbar
{
    NSString *tbit;
    NSMutableArray *ma = [NSMutableArray array];
    
    // Fill the array with strings
	tbit = @"Add Subject";
	[ma addObject:tbit];
	tbit = @"Remove Subject";
	[ma addObject:tbit];
	tbit = @"Add Task";
	[ma addObject:tbit];
	tbit = @"Remove Task";
	[ma addObject:tbit];
	tbit = @"Date Picker";
	[ma addObject:tbit];
	tbit = @"Archive Task";
	[ma addObject:tbit];
	tbit = @"Restore Task";
	[ma addObject:tbit];
    
    // Put in a couple of standard tool bar items
    [ma addObject:NSToolbarSeparatorItemIdentifier];
    [ma addObject:NSToolbarShowColorsItemIdentifier];
    return ma;
}

- (NSString *)windowNibName 
{
    return @"MyDocument";
}

- (void)windowControllerDidLoadNib:(NSWindowController *)windowController 
{
    [super windowControllerDidLoadNib:windowController];
    // user interface preparation code
}

- (IBAction)openHelpWindow:(id)sender {
	NSLog(@"%@", sender);
	[helpPanel makeKeyAndOrderFront:nil];
	NSLog(@"Opening");
}

@end
