//
//  SubjectTextCell.h
//  iProcrastinate
//
//  Created by Craig Otis on 6/18/07.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>


@interface SubjectTextCell : NSTextFieldCell {
	NSObject* delegate;
	NSString* iconKeyPath;
	NSString* primaryTextKeyPath;
	NSString* secondaryTextKeyPath;
}

- (void) setDataDelegate: (NSObject*) aDelegate;

- (void) setIconKeyPath: (NSString*) path;
- (void) setPrimaryTextKeyPath: (NSString*) path;
- (void) setSecondaryTextKeyPath: (NSString*) path;

@end

@interface NSObject(SubjectTextCellDelegate)

- (NSImage*) iconForCell: (SubjectTextCell*) cell data: (NSObject*) data;
- (NSString*) primaryTextForCell: (SubjectTextCell*) cell data: (NSObject*) data;
- (NSString*) secondaryTextForCell: (SubjectTextCell*) cell data: (NSObject*) data;

					   // optional: give the delegate a chance to set a different data object
					   // This is especially useful for those cases where you do not want that NSCell creates copies of your data objects (e.g. Core Data objects).
					   // In this case you bind a value to the NSTableColumn that enables you to retrieve the correct data object. You retrieve the objects
					   // in the method dataElementForCell
- (NSObject*) dataElementForCell: (SubjectTextCell*) cell;

	// optional
- (BOOL) disabledForCell: (SubjectTextCell*) cell data: (NSObject*) data;

@end
